bifunctors-5.4.2: Bifunctors

Copyright | (C) 2008-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | non-portable
Safe Haskell | Safe
Language | Haskell98

Data.Bifunctor.Join

Description

Synopsis

- newtype Join p a = Join {
  - runJoin :: p a a
  }

# Documentation

newtype Join p a Source #

Make a `Functor` over both arguments of a `Bifunctor`.

Constructors

Join |

Fields

- runJoin :: p a a

Instances

Bifunctor p => Functor (Join * p) Source # |
Methods fmap :: (a -> b) -> Join * p a -> Join * p b # (<$) :: a -> Join * p b -> Join * p a #
Biapplicative p => Applicative (Join * p) Source # |
Methods pure :: a -> Join * p a # (<*>) :: Join * p (a -> b) -> Join * p a -> Join * p b # (*>) :: Join * p a -> Join * p b -> Join * p b # (<*) :: Join * p a -> Join * p b -> Join * p a #
Bifoldable p => Foldable (Join * p) Source # |

Methods

fold :: Monoid m => Join * p m -> m #

foldMap :: Monoid m => (a -> m) -> Join * p a -> m #

foldr :: (a -> b -> b) -> b -> Join * p a -> b #

foldr' :: (a -> b -> b) -> b -> Join * p a -> b #

foldl :: (b -> a -> b) -> b -> Join * p a -> b #

foldl' :: (b -> a -> b) -> b -> Join * p a -> b #

foldr1 :: (a -> a -> a) -> Join * p a -> a #

foldl1 :: (a -> a -> a) -> Join * p a -> a #

toList :: Join * p a -> [a] #

null :: Join * p a -> Bool #

length :: Join * p a -> Int #

elem :: Eq a => a -> Join * p a -> Bool #

maximum :: Ord a => Join * p a -> a #

minimum :: Ord a => Join * p a -> a #

sum :: Num a => Join * p a -> a #

product :: Num a => Join * p a -> a #

Bitraversable p => Traversable (Join * p) Source # |
Methods traverse :: Applicative f => (a -> f b) -> Join * p a -> f (Join * p b) # sequenceA :: Applicative f => Join * p (f a) -> f (Join * p a) # mapM :: Monad m => (a -> m b) -> Join * p a -> m (Join * p b) # sequence :: Monad m => Join * p (m a) -> m (Join * p a) #
Eq (p a a) => Eq (Join k p a) Source # |
Methods (==) :: Join k p a -> Join k p a -> Bool # (/=) :: Join k p a -> Join k p a -> Bool #
Ord (p a a) => Ord (Join k p a) Source # |
Methods compare :: Join k p a -> Join k p a -> Ordering # (<) :: Join k p a -> Join k p a -> Bool # (<=) :: Join k p a -> Join k p a -> Bool # (>) :: Join k p a -> Join k p a -> Bool # (>=) :: Join k p a -> Join k p a -> Bool # max :: Join k p a -> Join k p a -> Join k p a # min :: Join k p a -> Join k p a -> Join k p a #
Read (p a a) => Read (Join k p a) Source # |
Methods readsPrec :: Int -> ReadS (Join k p a) # readList :: ReadS [Join k p a] # readPrec :: ReadPrec (Join k p a) # readListPrec :: ReadPrec [Join k p a] #
Show (p a a) => Show (Join k p a) Source # |
Methods showsPrec :: Int -> Join k p a -> ShowS # show :: Join k p a -> String # showList :: [Join k p a] -> ShowS #
Generic (Join k p a) Source # |
Associated Types type Rep (Join k p a) :: * -> * # Methods from :: Join k p a -> Rep (Join k p a) x # to :: Rep (Join k p a) x -> Join k p a #
type Rep (Join k p a) Source # |
type Rep (Join k p a) = D1 (MetaData "Join" "Data.Bifunctor.Join" "bifunctors-5.4.2-D9NYUY1YNw7CNbta2tOtAS" True) (C1 (MetaCons "Join" PrefixI True) (S1 (MetaSel (Just Symbol "runJoin") NoSourceUnpackedness NoSourceStrictness DecidedLazy) (Rec0 (p a a))))